; SS_80B.COM
; How to assemble with Turbo Assembler (Borland) v.1.0:
; C:\ASM\TASM /T/Z SS_80B,,NUL,NUL
; C:\ASM\TLINK /T/X SS_80B
; DEL SS_80B.OBJ

def_min equ 5	; def_min <= 60
PROGSEGS EQU 5

writeloc macro x
%OUT Length of resident portion: x
endm

check macro m1,v1,m2,v2
IFDIF <v1>,<v2>
%OUT m1: v1, m2: v2
%OUT ERROR: Numbers must be equal
ENDIF
.ERRDIF <v1>,<v2>
endm

generate_number macro x
IF x GE 100
db (x / 100 ) or '0'
ENDIF
IF x GE 10
db ((x mod 100) / 10 ) or '0'
ENDIF
db (x mod 10 ) or '0'
endm

.model tiny
; .stack 100h ; 80h is al meer dan genoeg !

.code
org 100h

start:
	jmp realstart

dark equ 0
counter equ 1
dark_bx equ byte ptr cs:[bx]
counter_bx equ word ptr cs:[bx+1]

new09h proc far
	mov word ptr cs:[counter],0
nulval_es equ (offset $ - offset start) - 2
	db 0eah ;opcode for jmp ....:....
	previsr09h dd 11111111h
endp

new1Ch proc far
	push ax
	push bx
	xor bx,bx
	mov ax,counter_bx
	cmp ax,def_min*1092d
maxcounter equ (offset $ - offset start) - 2
testblock:
	je reset
	ja skip
;jb
	or ax,ax
	jnz no_reset
	cmp dark_bx,al	;als ax dus nul is
	je no_reset ;als 0 dan is het scherm al aan
reset:
	push dx
	push ds
	mov ds,bx
no_vga: ; e.g., hercules; may be replaced by VGA !!!
	mov dx, ds:[463h] ;video control port
	add dx,4
	mov al,byte ptr ds:[465h]
	xor al,1000b
	mov ds:[465h],al
	out dx,al
	not dark_bx
no_vgalength equ $-no_vga

	pop ds
	pop dx

no_reset:
	inc counter_bx

skip:
	pop bx
	pop ax

endtestblock:
	db 0eah ;opcode for jmp ....:....
	previsr1Ch dd 11111111h

endp

l1 equ 16-((offset $ - offset start) mod 16)
if l1 lt 16
db l1 dup (90h)
endif

res_length equ $ - start
writeloc %res_length

vga proc near
	mov dx, ds:[463h] ;video control port
	add dx,6
	in al,dx
	mov dx,03c0h
	mov al,dark_bx ;screen_off = 20h, dan dus aan
	out dx,al
	xor dark_bx,20h ;0 = aan, zet uit ; 20h = uit, zet aan
endp

vgalength equ $ - vga

check vgalength,%vgalength,no_vgalength,%no_vgalength

compare_cs_es proc near	; cx affected
	mov ax,es
	dec ax
	mov es,ax
	mov bx, es:[1]
	mov cx, es:[3]
	inc ax
	mov es,ax

	cmp bx,ax	;kenmerk van programma
	jne differences
	cmp cx,PROGSEGS ; arena header: 3 = length
	jne differences

	CLD

	push es
	mov ax,es
	dec ax
	mov es,ax
	mov si,offset blackout
	mov di,8
	mov cx,8
	repz cmpsb
	pop es
	jne differences

	mov si,offset testblock
	mov di,offset testblock-start
	mov cx,offset endtestblock-testblock
	repz cmpsb
	jne differences

	mov dx,word ptr es:[counter]
	xor ax,ax
	mov word ptr es:[counter],ax
	mov bx,10h
loopouter:
	mov cx,0ffffh
loopinner:
	cmp ax,word ptr es:[counter]
	jne no_differences
	loop loopinner
	dec bx
	jnz loopouter
	mov word ptr es:[counter],dx ; restore
differences:	; NOT FOUND
	stc
	ret
no_differences:	; FOUND
	clc
	ret
endp

new23h proc far
	iret
endp

write_al_si proc near
	mov cl,10d
nextdecimal:
	xor ah,ah
	div cl
	or ah,'0'
	dec si
	mov byte ptr [si],ah
	or al,al
	jnz nextdecimal
	mov dx,si
	call writeln
	ret
endp

uninstall proc near
	push es
	mov ax,351Ch
	int 21h
	mov ax,es
	pop es
	mov cx,es
	cmp ax,cx
	jne u_error
	cmp bx,offset new1ch - offset start
	jne u_error

	push es
	mov ax,3509h
	int 21h
	mov ax,es
	pop es
	mov cx,es
	cmp ax,cx
	jne u_error
	cmp bx,offset new09h - offset start
	jne u_error

; de twee es'en nog vergelijken ?


; probeer te dealloceren

	push es
	mov ah,49h	;free environment
	int 21h
	pop es
	jc u_error
	push ds
	mov ax,word ptr es:[(previsr09h-start)+2] ;segment
	mov ds,ax
	mov dx,word ptr es:[(previsr09h-start)] ;offset
	mov ax,2509h
	int 21h
	mov ax,word ptr es:[(previsr1ch-start)+2] ;segment
	mov ds,ax
	mov dx,word ptr es:[(previsr1ch-start)] ;offset
	mov ax,251ch
	int 21h
	pop ds
	mov dx,offset msg_uninstalled
	jmp short uuu
u_error:
	mov dx,offset msg_cannot
uuu:
	call writeln
	ret
endp

install proc near
	mov es, ds:[2ch]	; psp:2ch = environment segment
	mov ax,es
	mov bx,cs
	cmp ax,bx
	jnb wronglocation
	mov bx,PROGSEGS 	; newblocksize
	mov ah,4ah	; new size
	int 21h
	jnc do_install

	mov dx,offset msg_not_installed
	call writeln
	mov dx,offset msg_insuff
	call writeln
	jmp short abort
wronglocation:
	mov dx,offset msg_not_installed
	call writeln
	mov dx,offset msg_loc
	call writeln
abort:
	mov ax,4cffh
	int 21h

do_install:

	mov ax,es
	dec ax
	mov es,ax	; MCB OF ENVIRONMENT
	inc ax
	mov es:[1],ax

	mov si,offset blackout
	mov di,8
	mov cx,8
	cld
	repz movsb

	mov es,ax ; environment

	mov si,offset start
	xor di,di
	mov cx,res_length
	cld
	repz movsb

	push es
	pop ds	; BELANGRIJK

	mov dx,offset new1Ch-offset start
	mov ax,251Ch
	int 21h

	mov dx,offset new09h-offset start
	mov ax,2509h
	int 21h

	push cs
	pop ds

	mov dx,offset msg_installed
	call writeln
	ret
endp

realstart:
	xor ax,ax
	mov byte ptr [start],al
	mov word ptr [start+1],ax

	mov dx,offset new23h
	mov ax,2523h
	int 21h

	mov dx,offset msg_init
	call writeln
	mov dx,offset msg_info
	call writeln
	mov ah,12h
	mov bl,10h
	mov bh,0ffh
	mov cx,0ffffh
	int 10h
	cmp bh,0ffh
	je no_vga_present
	cmp cx,0ffffh
	je no_vga_present
	cmp bl,03h
	ja no_vga_present

;verplaats
	mov si,offset vga
	mov di,offset no_vga
	mov cx,vgalength
	cld
	repz movsb

no_vga_present:
	mov ax,351Ch
	int 21h
	mov word ptr [previsr1Ch],bx
	mov word ptr [previsr1Ch+2],es
	cmp bx,offset new1ch - offset start
	jne unequal1Ch
	call compare_cs_es
	jnc found
unequal1Ch:
	mov ax,3509h
	int 21h
	mov word ptr [previsr09h],bx
	mov word ptr [previsr09h+2],es
	cmp bx,offset new09h - offset start
	jne unequal09h
	call compare_cs_es
	jnc found
unequal09h:

	mov cx,0f000h-70h
	mov ax,70h
	mov es,ax
cmp_loop:
	push cx
	call compare_cs_es
	pop cx
	jnc found
cmp_again:
	mov ax,es
	inc ax
	mov es,ax
	loop cmp_loop

	call install
found:

	mov word ptr es:[nulval_es],0h
	mov word ptr es:[counter],0

	mov si,80h
	cld
	lodsb
	mov cl,al
	xor ch,ch
	jcxz skippara_temp
	jmp short b_again
skippara_temp:
	jmp skippara

b_again:
	lodsb	;search for first parameter (number)
	cmp al,'!'
	je immediate
	cmp al,'-'
	je suspend
	cmp al,'*'
	je try_uninstall
	sub al,'0'
	cmp al,9
	jna num
	loop b_again
	jmp short skippara
num:
	xor bx,bx
n_again:
	xor ah,ah
	xchg bx,ax ; bx: de vorige
	push cx
	mov cl,10
	mul cl ; AL*CL -> AX
	pop cx
	add bx,ax
	cmp bh,0
	jne endpara ;"overflow"
	lodsb
	sub al,'0'
	cmp al,9
	ja endpara
	loop n_again
	jmp short endpara

immediate:
	mov ax,word ptr es:[maxcounter]
	dec ax
	mov word ptr es:[counter],ax
	mov cx,0ffffh
dark_again:
	cmp byte ptr es:[dark],0
	jne dark_done
	loop dark_again
dark_done:
	mov dx,offset msg_immediate
	jmp short www
suspend:
	mov word ptr es:[nulval_es],-1
	mov word ptr es:[counter],-1
	mov dx,offset msg_suspended
www:
	call writeln
	jmp short end_program

try_uninstall:
	call uninstall
	jmp short end_program

endpara:
	mov ax,bx
	cmp ax,0
	ja testabove
	mov ax,1
testabove:
	cmp ax,60
	jna para_ok
	mov ax,60

para_ok:
	mov cx,1092 ; tikken /minuut
	mul cx ; 60 * 1092 = 0fff0h
	; result in DX:AX !!!!
	mov word ptr es:[maxcounter],ax

skippara:
	mov dx,offset msg_minutes
	call writeln

	mov ax,word ptr es:[maxcounter]
	xor dx,dx
	mov cx,1092
	div cx
	mov si,offset num_minutes
	call write_al_si

end_program:
	mov ax,4c00h ;finish, exit code = ok
	int 21h

writeln proc near
	push ax
	mov ah,9
	int 21h
	pop ax
	ret
endp

msg_init db 13,10
blackout:
db "SS_80B",13,10
db "A screen saver which uses only 80 bytes of memory.",13,10
db "(C) Dr GJC Lokhorst 16 Feb 93.",13,10
db "Tested with Hercules/VGA cards, MS-DOS 3.3 - 5.0",13,10
db "Usage: SS_80B [nn][*][-][!]",13,10
db "Meaning: minutes, remove, suspend, "
msg_immediate db "immediate",13,10,"$"

msg_info db "Info: $"

msg_not_installed db "not installed. Environment $"
msg_insuff db "is too small",13,10,"$"
msg_loc db "at unsuitable location",13,10,"$"

msg_installed db "installed. $"

msg_minutes db "time-out value = $xx"
num_minutes db " minute(s)",13,10,"$"
msg_suspended db "suspended",13,10,"$"
msg_cannot db "cannot un-install",13,10,"$"
msg_uninstalled db "un-installed",13,10,"$"

end start

;write_hex_ax proc near
;	call write_hex_al
;write_hex_al proc near
;	xchg ah,al
;	mov bx,ax
;	shr al,1
;	shr al,1
;	shr al,1
;	shr al,1
;	call makehex_half
;	and al,0fh
;makehex_half proc near
;	cmp al,10
;	jb digit
;	add al,7
;digit:
;	add al,'0'
;	mov [si],al
;	inc si
;	mov ax,bx
;	ret
;endp
;endp
;endp
;
;	mov ah,30h
;	int 21h
;	cmp al,3
;	jb low_dos
;
;	mov ah,062h
;	int 21h
;	mov [psp],bx
;low_dos:

